/* -*-c-*-
 *
 * $Id: prim.h,v 1.1 1999/12/22 15:58:59 mdw Exp $
 *
 * Finding primitive elements
 *
 * (c) 1999 Straylight/Edgeware
 */

/*----- Licensing notice --------------------------------------------------* 
 *
 * This file is part of Catacomb.
 *
 * Catacomb is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 * 
 * Catacomb is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with Catacomb; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

/*----- Revision history --------------------------------------------------* 
 *
 * $Log: prim.h,v $
 * Revision 1.1  1999/12/22 15:58:59  mdw
 * Search for primitive elements using prime-search equipment.
 *
 */

#ifndef CATACOMB_PRIM_H
#define CATACOMB_PRIM_H

#ifdef __cplusplus
  extern "C" {
#endif

/*----- Header files ------------------------------------------------------*/

#include <stddef.h>

#ifndef CATACOMB_MP_H
#  include "mp.h"
#endif

#ifndef CATACOMB_MPMONT_H
#  include "mpmont.h"
#endif

#ifndef CATACOMB_PGEN_H
#  include "pgen.h"
#endif

/*----- Data structures ---------------------------------------------------*/

/* --- @prim_ctx@ --- *
 *
 * All fields must be configured by the client.  Set @n@ to zero to discover
 * generators of the subgroup of order %$m / f$%.
 */

typedef struct prim_ctx {
  mpmont mm;				/* Montgomery context for modulus */
  mp *f;				/* Array of factors */
  size_t n;				/* Number of factors */
} prim_ctx;

/*----- Functions provided ------------------------------------------------*/

/* --- @prim_test@ --- */

extern int prim_test(int /*rq*/, pgen_event */*ev*/, void */*p*/);

/* --- @prim_step@ --- */

extern int prim_step(int /*rq*/, pgen_event */*ev*/, void */*p*/);

/*----- That's all, folks -------------------------------------------------*/

#ifdef __cplusplus
  }
#endif

#endif
